(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory(require('react')) :
  typeof define === 'function' && define.amd ? define(['react'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, global['react-view-splitter'] = factory(global.React));
}(this, (function (React) { 'use strict';

  function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

  var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

  function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);

    if (Object.getOwnPropertySymbols) {
      var symbols = Object.getOwnPropertySymbols(object);

      if (enumerableOnly) {
        symbols = symbols.filter(function (sym) {
          return Object.getOwnPropertyDescriptor(object, sym).enumerable;
        });
      }

      keys.push.apply(keys, symbols);
    }

    return keys;
  }

  function _objectSpread2(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};

      if (i % 2) {
        ownKeys(Object(source), true).forEach(function (key) {
          _defineProperty(target, key, source[key]);
        });
      } else if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
      } else {
        ownKeys(Object(source)).forEach(function (key) {
          Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
      }
    }

    return target;
  }

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  function _extends() {
    _extends = Object.assign || function (target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i];

        for (var key in source) {
          if (Object.prototype.hasOwnProperty.call(source, key)) {
            target[key] = source[key];
          }
        }
      }

      return target;
    };

    return _extends.apply(this, arguments);
  }

  function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {};
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;

    for (i = 0; i < sourceKeys.length; i++) {
      key = sourceKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      target[key] = source[key];
    }

    return target;
  }

  function _objectWithoutProperties(source, excluded) {
    if (source == null) return {};

    var target = _objectWithoutPropertiesLoose(source, excluded);

    var key, i;

    if (Object.getOwnPropertySymbols) {
      var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

      for (i = 0; i < sourceSymbolKeys.length; i++) {
        key = sourceSymbolKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
        target[key] = source[key];
      }
    }

    return target;
  }

  function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
  }

  function _toConsumableArray(arr) {
    return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
  }

  function _arrayWithoutHoles(arr) {
    if (Array.isArray(arr)) return _arrayLikeToArray(arr);
  }

  function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) return arr;
  }

  function _iterableToArray(iter) {
    if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
  }

  function _iterableToArrayLimit(arr, i) {
    var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]);

    if (_i == null) return;
    var _arr = [];
    var _n = true;
    var _d = false;

    var _s, _e;

    try {
      for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"] != null) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  function _unsupportedIterableToArray(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _arrayLikeToArray(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(o);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
  }

  function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length) len = arr.length;

    for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

    return arr2;
  }

  function _nonIterableSpread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }

  function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }

  function _createForOfIteratorHelper(o, allowArrayLike) {
    var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];

    if (!it) {
      if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
        if (it) o = it;
        var i = 0;

        var F = function () {};

        return {
          s: F,
          n: function () {
            if (i >= o.length) return {
              done: true
            };
            return {
              done: false,
              value: o[i++]
            };
          },
          e: function (e) {
            throw e;
          },
          f: F
        };
      }

      throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
    }

    var normalCompletion = true,
        didErr = false,
        err;
    return {
      s: function () {
        it = it.call(o);
      },
      n: function () {
        var step = it.next();
        normalCompletion = step.done;
        return step;
      },
      e: function (e) {
        didErr = true;
        err = e;
      },
      f: function () {
        try {
          if (!normalCompletion && it.return != null) it.return();
        } finally {
          if (didErr) throw err;
        }
      }
    };
  }

  var Axes = {
    X: 'x',
    Y: 'y'
  };
  var Size = {
    Width: "width",
    Height: "height"
  };
  var Side = {
    Left: "left",
    Right: "right",
    Top: "top",
    Bottom: "bottom"
  };

  var isCallbackRef = function isCallbackRef(callback) {
    return !callback || typeof callback === 'function';
  };
  var toFnRef = function toFnRef(ref) {
    if (isCallbackRef(ref)) {
      return ref;
    }

    return function (value) {
      (ref !== null && ref !== void 0 ? ref : {}).current = value;
    };
  };
  function mergeRefs() {
    for (var _len = arguments.length, refs = new Array(_len), _key = 0; _key < _len; _key++) {
      refs[_key] = arguments[_key];
    }

    var fnRefs = refs.map(function (ref) {
      return toFnRef(ref);
    });
    return function (value) {
      fnRefs.forEach(function (fnRef) {
        return fnRef && fnRef(value);
      });
    };
  }
  /**
   * Create and returns a single callback ref composed from two other Refs.
   *
   * ```tsx
   * const Button = React.forwardRef((props, ref) => {
   *   const [element, attachRef] = useCallbackRef<HTMLButtonElement>();
   *   const mergedRef = useMergedRefs(ref, attachRef);
   *
   *   return <button ref={mergedRef} {...props}/>
   * })
   * ```
   *
   * @param refA A Callback or mutable Ref
   * @param refB A Callback or mutable Ref
   * @param refs another refs or mutable Ref
   * @category refs
   */

  function useMergedRefs(refA, refB) {
    for (var _len2 = arguments.length, refs = new Array(_len2 > 2 ? _len2 - 2 : 0), _key2 = 2; _key2 < _len2; _key2++) {
      refs[_key2 - 2] = arguments[_key2];
    }

    return React__default['default'].useMemo(function () {
      return mergeRefs.apply(void 0, [refA, refB].concat(refs)); // eslint-disable-next-line react-hooks/exhaustive-deps
    }, [refA, refB].concat(refs));
  }

  function split(panes, pair, responsive) {
    var result = pair.map(function (id) {
      return [id];
    });

    var _loop = function _loop(idx, _index) {
      if (!pair.some(function (id) {
        return id === panes[idx];
      })) {
        if (responsive) {
          Array.prototype.splice.call(result[~~(idx > _index)], idx % _index, 0, panes[idx]);
        } else {
          result.splice(idx, 0, panes[idx]);
        }
      } else {
        _index = panes.indexOf(panes[idx]);
      }

      index = _index;
    };

    for (var idx = 0, index = panes.indexOf(pair[idx]); idx < panes.length; idx++) {
      _loop(idx, index);
    }

    return result;
  }

  var rHyphen = /-(.)/g;
  function pascalCase(str) {
    return str[0].toUpperCase() + str.replace(rHyphen, function (_, chr) {
      return chr.toUpperCase();
    }).slice(1);
  }

  function createAs(prefix) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    var Component = options.Component,
        defaultProps = options.defaultProps,
        _options$displayName = options.displayName,
        displayName = _options$displayName === void 0 ? pascalCase(prefix) : _options$displayName;
    var RefComponent = /*#__PURE__*/React__default['default'].forwardRef(function () {
      var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          className = _ref.className,
          _ref$as = _ref.as,
          As = _ref$as === void 0 ? Component || 'div' : _ref$as,
          props = _objectWithoutProperties(_ref, ["className", "as"]);

      var ref = arguments.length > 1 ? arguments[1] : undefined;
      return /*#__PURE__*/React__default['default'].createElement(As, _extends({
        ref: ref,
        className: "".concat(prefix, " ").concat(className !== null && className !== void 0 ? className : '').trim()
      }, props));
    });
    RefComponent.displayName = displayName;
    RefComponent.defaultProps = defaultProps;
    return RefComponent;
  }

  function addRef(refs, el) {
    if (!refs.current) {
      throw new Error("Ref isn't initialized");
    }

    if (el && !refs.current.includes(el)) {
      refs.current.push(el);
    }
  }

  function isSyntheticEvent(event) {
    return event.nativeEvent instanceof Event;
  }

  function clearSizes (elements) {
    Object.keys(Size).forEach(function (size) {
      var targetSize = Size[size];
      elements.forEach(function (element) {
        element.style[targetSize] = '';
      });
    });
  }

  function getCoordinates(event) {
    var nativeEvent;

    if (isSyntheticEvent(event)) {
      nativeEvent = event.nativeEvent;
    } else {
      nativeEvent = event;
    }

    if (nativeEvent instanceof MouseEvent) {
      var _ref;

      return _ref = {}, _defineProperty(_ref, Axes.X, nativeEvent.clientX), _defineProperty(_ref, Axes.Y, nativeEvent.clientY), _ref;
    }

    if (nativeEvent instanceof TouchEvent) {
      var _nativeEvent$touches$, _ref2;

      var firstTouch = (_nativeEvent$touches$ = nativeEvent.touches[0]) !== null && _nativeEvent$touches$ !== void 0 ? _nativeEvent$touches$ : nativeEvent.changedTouches[0];
      return _ref2 = {}, _defineProperty(_ref2, Axes.X, firstTouch.clientX), _defineProperty(_ref2, Axes.Y, firstTouch.clientY), _ref2;
    }

    throw 'Event type not supported';
  }

  function rect(source) {
    return source.getBoundingClientRect();
  }

  function getPointerOffset(event) {
    var nativeEvent;

    if (isSyntheticEvent(event)) {
      nativeEvent = event.nativeEvent;
    } else {
      nativeEvent = event;
    }

    if (nativeEvent instanceof MouseEvent) {
      var _ref;

      return _ref = {}, _defineProperty(_ref, Axes.X, nativeEvent.offsetX), _defineProperty(_ref, Axes.Y, nativeEvent.offsetY), _ref;
    }

    if (nativeEvent instanceof TouchEvent) {
      var _nativeEvent$touches$, _ref2;

      var firstTouch = (_nativeEvent$touches$ = nativeEvent.touches[0]) !== null && _nativeEvent$touches$ !== void 0 ? _nativeEvent$touches$ : nativeEvent.changedTouches[0];
      var targetRect = rect(firstTouch.target);
      return _ref2 = {}, _defineProperty(_ref2, Axes.X, firstTouch.clientX - targetRect.left), _defineProperty(_ref2, Axes.Y, firstTouch.clientY - targetRect.top), _ref2;
    }

    throw 'Event type not supported';
  }

  function sizeTarget(axis) {
    return axis === Axes.X ? Size.Width : Size.Height;
  }

  function getPortSize(source, sizeTarget) {
    return sizeTarget === 'width' ? source.clientWidth : source.clientHeight;
  }

  function getCalcBarSize(length, barSize) {
    return barSize * (length - 1) / length;
  }

  function getEdges(panes, pair, rSizes, rMinSizes, portSize, barSize, portOffset, responsive) {
    var edges = [portOffset, portSize + portOffset];
    var entry = panes.indexOf(pair[1]);
    var sizes = rSizes.map(function (size) {
      return size * portSize / 100;
    });
    var calcBarSize = getCalcBarSize(panes.length, barSize);
    var minSizes = rMinSizes.map(function (size) {
      return Math.max(size * portSize / 100, calcBarSize);
    });
    return [panes.slice(0, entry), panes.slice(entry)].map(function (block, index) {
      var blockSize = block.map(function (paneIdx) {
        return !responsive && !pair.some(function (p) {
          return p === paneIdx;
        }) ? sizes[panes.indexOf(paneIdx)] : minSizes[panes.indexOf(paneIdx)];
      }).reduce(function (a, b) {
        return a + b - calcBarSize;
      }, barSize * (block.length - 1));
      /* ~~(index > 0) - 1 | 1  convert true to 1 and false to -1 */

      return edges[index] + blockSize * -(~~(index > 0) - 1 | 1);
    });
  }

  function getAbsoluteBlockSizes(portSize, block, panes, sizes, minSizes, barSize) {
    var calcBarSize = getCalcBarSize(panes.length, barSize);
    var blockIndices = block.map(function (paneIndex) {
      return panes.indexOf(paneIndex);
    });
    var absSizes = blockIndices.map(function (paneIndex) {
      return sizes[paneIndex] * portSize / 100;
    });
    var absSize = absSizes.reduce(function (a, b) {
      return a + b;
    }, 0);
    var absMinSizes = blockIndices.map(function (paneIdx) {
      return Math.max(minSizes[paneIdx] * portSize / 100, calcBarSize);
    });
    var absMinSize = absMinSizes.reduce(function (a, b) {
      return a + b;
    }, 0);
    var availableAbsSizes = absSizes.map(function (size, i) {
      return size - absMinSizes[i];
    });
    var availableAbsSize = absSize - absMinSize;
    return {
      size: absSize,
      sizes: absSizes,
      minSize: absMinSize,
      minSizes: absMinSizes,
      availableSize: availableAbsSize,
      availableSizes: availableAbsSizes
    };
  }

  function getSizes(panes, blocks, rSizes, rMinSizes, portSize, offset, barSize) {
    var indices = panes.slice();
    var ltr = offset > 0;
    var absSizes = rSizes.map(function (size) {
      return size * portSize / 100;
    });
    var activeBlocks = ltr ? blocks.reverse() : blocks.slice();
    var reducedSize = 0;
    var absOffset = Math.abs(offset);

    var _iterator = _createForOfIteratorHelper(activeBlocks.entries()),
        _step;

    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var _step$value = _slicedToArray(_step.value, 2),
            idx = _step$value[0],
            activeBlock = _step$value[1];

        var reduce = idx === 0;
        var increase = idx === 1;
        var activeBlockIndices = activeBlock.map(function (paneIndex) {
          return indices.indexOf(paneIndex);
        });
        var activeBlockSizes = getAbsoluteBlockSizes(portSize, activeBlock, panes, rSizes, rMinSizes, barSize); // to prevent overflows

        if (reduce && activeBlockSizes.size - absOffset < activeBlockSizes.minSize) {
          absOffset = activeBlockSizes.size - activeBlockSizes.minSize;
        }

        if (reduce && activeBlockSizes.availableSize === 0) {
          continue;
        } // apply sizes for all panes in block


        var _iterator2 = _createForOfIteratorHelper(activeBlockIndices.entries()),
            _step2;

        try {
          for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
            var _step2$value = _slicedToArray(_step2.value, 2),
                jdx = _step2$value[0],
                index = _step2$value[1];

            if ( // if increase, evenly spread the offset
            // between panes in block 
            increase) {
              absSizes[index] += reducedSize / activeBlock.length;
            } else if ( // if reduce, apply the offset relatively
            // to the current available size of block
            // and current size of pane
            reduce) {
              var ratio = (activeBlockSizes.availableSize - absOffset) / activeBlockSizes.availableSize;
              absSizes[index] = activeBlockSizes.availableSizes[jdx] * ratio + activeBlockSizes.minSizes[jdx];
              reducedSize += absSizes[index];
            }
          }
        } catch (err) {
          _iterator2.e(err);
        } finally {
          _iterator2.f();
        }

        reducedSize = activeBlockSizes.size - reducedSize;
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }

    var absSize = absSizes.reduce(function (a, b) {
      return a + b;
    }, 0);

    if (absSize !== portSize) {
      absSizes.forEach(function (size, idx) {
        return absSizes[idx] = size * portSize / absSize;
      });
    }

    return absSizes.map(function (size) {
      return size / portSize * 100;
    });
  }

  function getActiveBlocks(layout) {
    var responsive = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
    var result = responsive // if responsive layout will be array of arrays
    ? layout.slice() // else needs leave only arrays
    : layout.filter(function (b) {
      return b instanceof Array;
    });
    return result;
  }

  function sideOrigin(axis) {
    return axis === Axes.X ? Side.Left : Side.Top;
  }

  function getMinSizes(length, minSize, defaultMinSizes) {
    return Array.isArray(defaultMinSizes) ? _toConsumableArray(defaultMinSizes) : new Array(length).fill(minSize);
  }

  function getSideTarget(axis) {
    return axis === Axes.X ? Side.Right : Side.Bottom;
  }

  function useDragging(isDragging, onMove, onMoveEnd) {
    var onMoveCallback = React__default['default'].useCallback(function (event) {
      onMove(getCoordinates(event));

      if (event.cancelable) {
        event.preventDefault();
      }
    }, [onMove]);
    var onMoveEndCallback = React__default['default'].useCallback(function (event) {
      onMoveEnd(getCoordinates(event));

      if (event.cancelable) {
        event.preventDefault();
      }
    }, [onMoveEnd]);
    React__default['default'].useEffect(function () {
      if (isDragging) {
        window.addEventListener('mousemove', onMoveCallback, {
          passive: false
        });
        window.addEventListener('touchmove', onMoveCallback, {
          passive: false
        });
        window.addEventListener('mouseup', onMoveEndCallback, {
          passive: false
        });
        window.addEventListener('touchend', onMoveEndCallback, {
          passive: false
        });
        window.addEventListener('touchcancel', onMoveEndCallback, {
          passive: false
        });
      } else {
        window.removeEventListener('mousemove', onMoveCallback);
        window.removeEventListener('touchmove', onMoveCallback);
        window.removeEventListener('mouseup', onMoveEndCallback);
        window.removeEventListener('touchend', onMoveEndCallback);
        window.removeEventListener('touchcancel', onMoveEndCallback);
      }

      return function () {
        window.removeEventListener('mousemove', onMoveCallback);
        window.removeEventListener('touchmove', onMoveCallback);
        window.removeEventListener('mouseup', onMoveEndCallback);
        window.removeEventListener('touchend', onMoveEndCallback);
        window.removeEventListener('touchcancel', onMoveEndCallback);
      };
    }, [isDragging, onMoveCallback, onMoveEndCallback]);
  }

  var ViewSplitterBar = /*#__PURE__*/React__default['default'].forwardRef(function (_ref, ref) {
    var _ref$as = _ref.as,
        Component = _ref$as === void 0 ? 'div' : _ref$as,
        onMoveStart = _ref.onMoveStart,
        _ref$className = _ref.className,
        className = _ref$className === void 0 ? "" : _ref$className,
        children = _ref.children,
        props = _objectWithoutProperties(_ref, ["as", "onMoveStart", "className", "children"]);

    var barRef = React__default['default'].useRef(null);
    var mergedRefs = useMergedRefs(ref, barRef);
    var onMoveStartRef = React__default['default'].useRef(onMoveStart);
    React__default['default'].useEffect(function () {
      onMoveStartRef.current = onMoveStart;
    }, [onMoveStart]);
    React__default['default'].useEffect(function () {
      var bar = barRef.current;
      var eventHandler = onMoveStartRef.current;

      if (bar) {
        bar.addEventListener('mousedown', eventHandler, {
          passive: false
        });
        bar.addEventListener('touchstart', eventHandler, {
          passive: false
        });
      }

      return function () {
        if (bar) {
          bar.removeEventListener('mousedown', eventHandler);
          bar.removeEventListener('touchstart', eventHandler);
        }
      };
    }, []);
    return /*#__PURE__*/React__default['default'].createElement(Component, _extends({
      ref: mergedRefs,
      className: "view-splitter-bar ".concat(className).trim()
    }, props), children);
  });
  ViewSplitterBar.displayName = "ViewSplitterBar";

  var ViewSplitterPane = /*#__PURE__*/React__default['default'].forwardRef(function (_ref, ref) {
    var _ref$as = _ref.as,
        Component = _ref$as === void 0 ? 'div' : _ref$as,
        children = _ref.children,
        props = _objectWithoutProperties(_ref, ["as", "children"]);

    return /*#__PURE__*/React__default['default'].createElement(Component, _extends({
      ref: ref,
      className: "view-splitter-pane"
    }, props), children);
  });
  ViewSplitterPane.displayName = "ViewSplitterPane";

  var ViewSplitterDecorator = createAs("view-splitter-decorator");
  var defaultDrag = {
    activeBarIndex: -1,
    isDragging: false,
    current: {
      x: 0,
      y: 0
    },
    offset: {
      x: 0,
      y: 0,
      left: 0,
      top: 0,
      right: 0,
      bottom: 0
    },
    pair: [],
    panes: []
  };
  var ViewSplitter = /*#__PURE__*/React__default['default'].forwardRef(function (_ref, ref) {
    var _ref$as = _ref.as,
        Component = _ref$as === void 0 ? 'div' : _ref$as,
        _ref$responsive = _ref.responsive,
        responsive = _ref$responsive === void 0 ? false : _ref$responsive,
        _ref$fluent = _ref.fluent,
        fluent = _ref$fluent === void 0 ? false : _ref$fluent,
        _ref$axis = _ref.axis,
        axis = _ref$axis === void 0 ? Axes.X : _ref$axis,
        _ref$barSize = _ref.barSize,
        barSize = _ref$barSize === void 0 ? 1 : _ref$barSize,
        _ref$minSize = _ref.minSize,
        minSize = _ref$minSize === void 0 ? 0 : _ref$minSize,
        _ref$className = _ref.className,
        className = _ref$className === void 0 ? "" : _ref$className,
        defaultSizes = _ref.sizes,
        defaultMinSizes = _ref.minSizes,
        onSizeChanged = _ref.onSizeChanged,
        children = _ref.children,
        props = _objectWithoutProperties(_ref, ["as", "responsive", "fluent", "axis", "barSize", "minSize", "className", "sizes", "minSizes", "onSizeChanged", "children"]);

    var paneRefs = React__default['default'].useRef([]);
    var barRefs = React__default['default'].useRef([]);
    var decoratorRef = React__default['default'].useRef();
    var portRef = React__default['default'].useRef(null);
    var startCoordinatesRef = React__default['default'].useRef({
      x: 0,
      y: 0
    });
    var onSizeChangedRef = React__default['default'].useRef(onSizeChanged);
    var decoratorDragRef = React__default['default'].useRef({
      positive: false,
      size: 0
    });
    var paneSizesRef = React__default['default'].useRef(defaultSizes !== null && defaultSizes !== void 0 ? defaultSizes : []);

    var _React$useState = React__default['default'].useState(defaultDrag),
        _React$useState2 = _slicedToArray(_React$useState, 2),
        drag = _React$useState2[0],
        setDrag = _React$useState2[1];

    var mergedRefs = useMergedRefs(ref, portRef);
    var clearStyles = React__default['default'].useCallback(function () {
      clearSizes(paneRefs.current);
      clearSizes(barRefs.current);
    }, []);
    var applyStyles = React__default['default'].useCallback(function () {
      var isDragging = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      var sizeTarget$1 = sizeTarget(axis);

      if (fluent || !isDragging) {
        var panes = paneRefs.current;
        var bars = barRefs.current;
        var calcBarSize = getCalcBarSize(paneRefs.current.length, barSize);
        panes.forEach(function (pane, idx) {
          pane.style[sizeTarget$1] = "calc(".concat(paneSizesRef.current[idx], "% - ").concat(calcBarSize, "px)");
        });
        bars.forEach(function (bar) {
          bar.style[sizeTarget$1] = barSize + 'px';
        });
      } else if (decoratorRef.current) {
        var _decoratorDragRef$cur = decoratorDragRef.current,
            positive = _decoratorDragRef$cur.positive,
            decoratorSize = _decoratorDragRef$cur.size;
        var sideTarget = getSideTarget(axis);

        var _sizeTarget = sizeTarget(axis);

        var sideOrigin$1 = sideOrigin(axis);
        decoratorRef.current.style[sideOrigin$1] = positive ? barSize + 'px' : 'auto';
        decoratorRef.current.style[sideTarget] = positive ? 'auto' : barSize + 'px';
        decoratorRef.current.style[_sizeTarget] = decoratorSize + 'px';
      }
    }, [axis, barSize, fluent]);
    var resetSizes = React__default['default'].useCallback(function () {
      paneSizesRef.current = defaultSizes !== null && defaultSizes !== void 0 ? defaultSizes : paneRefs.current.map(function () {
        return 100 / paneRefs.current.length;
      });
    }, [defaultSizes]);
    var onMoveStart = React__default['default'].useCallback(function (event) {
      var activeBarIndex = barRefs.current.indexOf(event.target);

      if (activeBarIndex !== -1 && portRef.current) {
        var start = getCoordinates(event);
        var portRect = rect(portRef.current);

        var offset = _objectSpread2(_objectSpread2({}, getPointerOffset(event)), {}, {
          left: portRect.left,
          top: portRect.top,
          right: portRect.right,
          bottom: portRect.bottom
        });

        var activeBar = barRefs.current[activeBarIndex];
        var previous = paneRefs.current.indexOf(activeBar.previousSibling);
        var next = paneRefs.current.indexOf(activeBar.nextSibling);

        var panes = _toConsumableArray(Array(paneRefs.current.length).keys());

        setDrag({
          offset: offset,
          current: start,
          activeBarIndex: activeBarIndex,
          isDragging: true,
          panes: panes,
          pair: [previous, next]
        });
        startCoordinatesRef.current = start;

        if (event.cancelable) {
          event.preventDefault();
        }
      }
    }, []);
    var onMove = React__default['default'].useCallback(function (current) {
      setDrag(function (last) {
        return _objectSpread2(_objectSpread2({}, last), {}, {
          current: current
        });
      });
    }, []);
    var onMoveEnd = React__default['default'].useCallback(function (current) {
      setDrag(function (last) {
        return _objectSpread2(_objectSpread2({}, last), {}, {
          current: current,
          isDragging: false,
          activeBarIndex: -1
        });
      });
    }, []);
    var onDragChanged = React__default['default'].useCallback(function (drag) {
      var pair = drag.pair,
          panes = drag.panes;
      var startPosition = startCoordinatesRef.current[axis];

      if (!portRef.current || drag.current[axis] === startPosition) {
        return false;
      }

      var panesCount = panes.length;
      var layout = split(panes, pair, responsive);
      var sizeTarget$1 = sizeTarget(axis);
      var sideOrigin$1 = sideOrigin(axis);
      var clientAxis = drag.current[axis];
      var offset = clientAxis - startPosition;
      var portSize = getPortSize(portRef.current, sizeTarget$1);
      var minSizes = getMinSizes(panesCount, minSize, defaultMinSizes);
      var activeBlocks = getActiveBlocks(layout);

      var sizes = _toConsumableArray(paneSizesRef.current);

      var positive = offset >= 0;

      if (fluent || !drag.isDragging) {
        var portOffset = drag.offset[sideOrigin$1];
        var edges = getEdges(panes, pair, sizes, minSizes, portSize, barSize, portOffset, responsive);
        var max = Math.max.apply(Math, _toConsumableArray(edges));
        var min = Math.min.apply(Math, _toConsumableArray(edges));
        var pointerOffset = drag.offset[axis];
        var newPaneSizes = getSizes(panes, activeBlocks, sizes, minSizes, portSize, offset, barSize);
        var currentPosition = clientAxis;

        if (currentPosition > max - (barSize - pointerOffset) || currentPosition < min + pointerOffset) {
          currentPosition = positive ? max - (barSize - pointerOffset) : min + pointerOffset;
        }

        paneSizesRef.current = newPaneSizes;
        startCoordinatesRef.current[axis] = currentPosition;
      } else {
        var absBlockSizes = getAbsoluteBlockSizes(portSize, activeBlocks[~~positive], panes, sizes, minSizes, barSize);
        decoratorDragRef.current = {
          positive: positive,
          size: Math.min(Math.abs(offset), absBlockSizes.availableSize)
        };
      }

      return true;
    }, [axis, barSize, fluent, minSize, responsive, defaultMinSizes]);
    paneRefs.current = [];
    barRefs.current = []; // use callback ref

    React__default['default'].useEffect(function () {
      onSizeChangedRef.current = onSizeChanged;
    }, [onSizeChanged]); // resize if drag changed

    React__default['default'].useEffect(function () {
      if (onDragChanged(drag)) {
        applyStyles(drag.isDragging);

        if (typeof onSizeChangedRef.current === 'function') {
          onSizeChangedRef.current(paneSizesRef.current);
        }
      }
    }, [drag, onDragChanged, applyStyles]); // if children has changed reset sizes and apply styles 

    React__default['default'].useEffect(function () {
      resetSizes();
      applyStyles();
    }, [children, resetSizes, applyStyles]); // clear and apply styles when axis has changed

    React__default['default'].useEffect(function () {
      clearStyles();
      applyStyles();
    }, [axis, clearStyles, applyStyles]);
    useDragging(drag.isDragging, onMove, onMoveEnd);
    return /*#__PURE__*/React__default['default'].createElement(Component, _extends({
      className: "".concat(className, " view-splitter view-splitter-").concat(axis).trim(),
      ref: mergedRefs
    }, props), children && Array.isArray(children) ? children.map(function (pane, idx) {
      return /*#__PURE__*/React__default['default'].createElement(React__default['default'].Fragment, {
        key: idx
      }, /*#__PURE__*/React__default['default'].createElement(ViewSplitterPane, {
        ref: function ref(el) {
          return addRef(paneRefs, el);
        }
      }, pane), idx < children.length - 1 && /*#__PURE__*/React__default['default'].createElement(ViewSplitterBar, {
        onMoveStart: onMoveStart,
        className: "".concat(idx === drag.activeBarIndex ? 'active' : ''),
        ref: function ref(el) {
          return addRef(barRefs, el);
        }
      }, !fluent && drag.isDragging && drag.activeBarIndex === idx && /*#__PURE__*/React__default['default'].createElement(ViewSplitterDecorator, {
        ref: decoratorRef
      })));
    }) : children);
  });
  ViewSplitter.displayName = "ViewSplitter";

  return ViewSplitter;

})));
